﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestModelFirst
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void btnAdd_Click(object sender, EventArgs e)
      {
         // Create a new purchase.
         Purchases NewPurchase = new Purchases();
         NewPurchase.Amount = new Decimal(5.99);
         NewPurchase.PurchaseDate = DateTime.Now;

         // Create a new customer and add the purchase.
         Customers NewCustomer = new Customers();
         NewCustomer.CustomerName = "Josh Bailey";

         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add the record and save it.
         context.Customers.Add(NewCustomer);
         context.Purchases.Add(NewPurchase);
         context.SaveChanges();

         // Display a success message.
         MessageBox.Show("Record Added");
      }

      private void btnQuery_Click(object sender, EventArgs e)
      {
          // Create the context.
          Rewards2ModelContainer context = new Rewards2ModelContainer();

          // Create the new customer list.
          IQueryable<Customers> CustomerList = null;

          try
          {
             // Obtain the customer list.
             CustomerList =
                 from cust in context.Customers
                 select cust;
          }
          catch (InvalidOperationException IOE)
          {
             // Show an error message.
             MessageBox.Show("Cannot Create the Connection!\r\n" +
                IOE.Message);

             // Exit the event handler.
             return;
          }
          catch (MetadataException ME)
          {
             // Show an error message.
             MessageBox.Show("Cannot Create the Connection!\r\n" +
                ME.Message);

             // Exit the event handler.
             return;
          }
          catch (DataException DE)
          {
             // Show an error message.
             MessageBox.Show("Unexpected Data Exception!\r\n" +
                DE.GetType().FullName + "\r\n" +
                DE.Message);

             // Exit the event handler.
             return;
          }
          catch (Exception Ex)
          {
             // Show an error message.
             MessageBox.Show("Unexpected Error!\r\n" +
                Ex.GetType().FullName + "\r\n" +
                Ex.Message);

             // Exit the event handler.
             return;
          }

          //// Obtain the customer list in list form.
          //List<Customers> CustomerList =
          //    (from cust in context.Customers
          //     select cust).ToList<Customers>();

          // Process each customer in the list.
          StringBuilder Output = 
              new StringBuilder("Customer List:");
          try
          {
             foreach (var Customer in CustomerList)
             {
                // Create a customer entry for each customer.
                Output.Append("\r\n" + Customer.CustomerName +
                    " has made purchases on: ");

                // Process each purchase for that particular customer.
                foreach (var Purchase in Customer.Purchases)
                   Output.Append("\r\n\t" + Purchase.PurchaseDate);
             }
          }
          catch (EntityException EE)
          {
             // Show an error message.
             MessageBox.Show("Cannot Open the Database!\r\n" +
                EE.Message + "\r\n\r\nDetails:\r\n" +
                EE.InnerException.Message + "\r\n" +
                EE.InnerException.GetType().FullName);

             // Exit the event handler.
             return;
          }
          catch (Exception Ex)
          {
             // Show an error message.
             MessageBox.Show("Unexpected Error!\r\n" +
                Ex.GetType().FullName + "\r\n" +
                Ex.Message);

             // Exit the event handler.
             return;
          }

          // Display the result on screen.
          MessageBox.Show(Output.ToString());
      }
   }
}
